<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="用户名称" prop="userName">
        <el-input
          v-model="queryParams.userName"
          placeholder="请输入用户名称"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="店铺名称" prop="storeId">
        <el-input
          v-model="queryParams.storeName"
          placeholder="请输入店铺名称"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="类型" prop="bstType">
        <el-select v-model="queryParams.bstType" placeholder="请选择变化类型" clearable @change="handleQuery">
          <el-option
            v-for="dict in dict.type.lighting_num_change_type"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          @click="handleExport"
          v-has-permi="['bst:changeRecord:export']"
        >导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList" :columns="columns"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="changeRecordList" @selection-change="handleSelectionChange" :default-sort="defaultSort"  @sort-change="onSortChange">
      <el-table-column type="selection" width="55" align="center" />
      <template v-for="column of showColumns">
        <el-table-column
          :key="column.key"
          :label="column.label"
          :prop="column.key"
          :align="column.align"
          :min-width="column.minWidth"
          :sort-orders="orderSorts"
          :sortable="column.sortable"
          :show-overflow-tooltip="column.overflow"
          :width="column.width"
        >
          <template slot-scope="d">
            <template v-if="column.key === 'recordId'">
              {{d.row[column.key]}}
            </template>
            <template v-else-if="column.key === 'userName'">
              <div v-if="d.row.userName != null">
                <i class="el-icon-user"/>
                <user-link :id="d.row.userId" :text="d.row.userName" size="mini"/>
              </div>
            </template>
            <template v-else-if="column.key === 'bstType'">
              <div v-if="d.row.bstType != null">
                <dict-tag :value="d.row.bstType" :options="dict.type.lighting_num_change_type"/>
              </div>
            </template>
            <template v-else-if="column.key === 'storeName'">
              <div v-if="d.row.storeName != null">
                <i class="el-icon-takeaway-box"/>
                <store-link :id="d.row.storeId" :name="d.row.storeName" size="mini"/>
              </div>
            </template>
            <template v-else>
              {{d.row[column.key]}}
            </template>
          </template>
        </el-table-column>
      </template>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />
  </div>
</template>

<script>
import { listChangeRecord, getChangeRecord, delChangeRecord, addChangeRecord, updateChangeRecord } from "@/api/bst/changeRecord";
import { $showColumns } from '@/utils/mixins';
import FormCol from "@/components/FormCol/index.vue";
import UserLink from "@/views/system/user/UserLink.vue";
import StoreLink from "@/views/bst/store/StoreLink.vue";

// 默认排序字段
const defaultSort = {
  prop: "createTime",
  order: "descending"
}

export default {
  name: "ChangeRecord",
  mixins: [$showColumns],
  dicts: ['lighting_num_change_type'],
  components: {StoreLink, UserLink, FormCol},
  props: {
    query: {
      type: Object,
      default: () => ({})
    }
  },
  data() {
    return {
      span: 24,
      // 字段列表
      columns: [
        {key: 'userName', visible: true, label: '用户名', minWidth: null, sortable: true, overflow: false, align: 'center', width: null},
        {key: 'storeName', visible: true, label: '店铺名', minWidth: null, sortable: true, overflow: false, align: 'center', width: null},
        {key: 'bstType', visible: true, label: '类型', minWidth: null, sortable: true, overflow: false, align: 'center', width: null},
        {key: 'number', visible: true, label: '变动次数', minWidth: null, sortable: true, overflow: false, align: 'center', width: null},
        {key: 'beforeNum', visible: true, label: '变动前次数', minWidth: null, sortable: true, overflow: false, align: 'center', width: null},
        {key: 'reason', visible: true, label: '原因', minWidth: null, sortable: true, overflow: false, align: 'center', width: null},
        {key: 'afterNum', visible: true, label: '变动后次数', minWidth: null, sortable: true, overflow: false, align: 'center', width: null},
      ],
      // 排序方式
      orderSorts: ['ascending', 'descending', null],
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 爆灯次数变化表格数据
      changeRecordList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      defaultSort,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 20,
        orderByColumn: defaultSort.prop,
        isAsc: defaultSort.order,
        userId: null,
        storeId: null,
        number: null,
        beforeNum: null,
        afterNum: null,
        bstType: null,
        bstId: null,
        reason: null,
      },
      // 表单参数
      form: {},
    };
  },
  created() {
    this.queryParams = {
      ...this.queryParams,
      ...this.query
    }
    this.getList();
  },
  methods: {
    /** 当排序按钮被点击时触发 **/
    onSortChange(column) {
      if (column.order == null) {
        this.queryParams.orderByColumn = defaultSort.prop;
        this.queryParams.isAsc = defaultSort.order;
      } else {
        this.queryParams.orderByColumn = column.prop;
        this.queryParams.isAsc = column.order;
      }
      this.getList();
    },
    /** 查询爆灯次数变化列表 */
    getList() {
      this.loading = true;
      listChangeRecord(this.queryParams).then(response => {
        this.changeRecordList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        recordId: null,
        userId: null,
        storeId: null,
        number: null,
        beforeNum: null,
        afterNum: null,
        bstType: null,
        bstId: null,
        reason: null,
        createTime: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.recordId)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加爆灯次数变化";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const recordId = row.recordId || this.ids
      getChangeRecord(recordId).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改爆灯次数变化";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.recordId != null) {
            updateChangeRecord(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addChangeRecord(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const recordIds = row.recordId || this.ids;
      this.$modal.confirm('是否确认删除爆灯次数变化编号为"' + recordIds + '"的数据项？').then(function() {
        return delChangeRecord(recordIds);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download('bst/changeRecord/export', {
        ...this.queryParams
      }, `changeRecord_${new Date().getTime()}.xlsx`)
    }
  }
};
</script>
